------------------------------------------------------------------------------------------
-- PICTURE: Export picture to assembler array                                           --
-- (8-bit GBA SP 2D)                                                                    --
-- by HoraK-FDF                                                                         --
-- pic_db_Export_Pic2asm_8bit_Tiles_SP2D_GBA.lua                                        --
------------------------------------------------------------------------------------------

    --- Returns HEX representation of num
    function num2hex(num)
        local hexstr = '0123456789abcdef'
        local s = ''
        while num > 0 do
            local mod = math.fmod(num, 16)
            s = string.sub(hexstr, mod+1, mod+1) .. s
            num = math.floor(num / 16)
        end
        if s == '' then s = '0' end
        return s
    end

function replace_char(pos, str, char)
 if char == nil or char == "" then
  return str:sub(1, pos-1) .. str:sub(pos+1)
 else
  return str:sub(1, pos-1) .. char .. str:sub(pos+1)
 end
end


function replace_all_chars(str, char, replacechar)
 tmpstr=str
 repeat
  charstart, charend=string.find(tmpstr, char)
  if charstart ~= nil then
   tmpstr=replace_char(charstart, tmpstr, replacechar)
  end
 until charstart == nil
 return tmpstr
end

------------------------------------------------------------------------------

w, h = getpicturesize()

tail="_8bit"

filename, filepath = getfilename()
path_seperator=package.config:sub(1,1);
filename_without_ext=string.gsub(filename, "%..-$", "")
local file = io.open(filepath..path_seperator..filename_without_ext..tail..".raw.s", "w")
size=h*w

const_name_prefix=replace_all_chars(filename_without_ext, "-", "_")
const_name_prefix=replace_all_chars(const_name_prefix, "%(", "")
const_name_prefix=replace_all_chars(const_name_prefix, "%)", "")
const_name_prefix=replace_all_chars(const_name_prefix, "+", "")
first_char = const_name_prefix:sub(1,1)
if string.match (first_char, "%d") ~= nil then
 const_name_prefix="const_"..const_name_prefix
end

const_name_prefix=const_name_prefix..tail

-- messagebox("var", const_name_prefix)

file:write("@===============================================================================\n")
file:write("@ "..const_name_prefix.."_Tiles_Size\n")
file:write("@===============================================================================\n")
file:write(".global "..const_name_prefix.."_Tiles_Size\n")
file:write(".type "..const_name_prefix.."_Tiles_Size, %object\n")
file:write(".section .rodata\n")
file:write(".align 1\n")
file:write(const_name_prefix.."_Tiles_Size:\n")
file:write(".hword "..size.."\n")
file:write("\n")
file:write("@===============================================================================\n")
file:write("@ "..const_name_prefix.."_Tiles_SizeX\n")
file:write("@===============================================================================\n")
file:write(".global "..const_name_prefix.."_Tiles_SizeX\n")
file:write(".type "..const_name_prefix.."_Tiles_SizeX, %object\n")
file:write(".section .rodata\n")
file:write(".align 1\n")
file:write(const_name_prefix.."_Tiles_SizeX:\n")
file:write(".hword "..w.."\n")
file:write("\n")
file:write("@===============================================================================\n")
file:write("@ "..const_name_prefix.."_Tiles_SizeY\n")
file:write("@===============================================================================\n")
file:write(".global "..const_name_prefix.."_Tiles_SizeY\n")
file:write(".type "..const_name_prefix.."_Tiles_SizeY, %object\n")
file:write(".section .rodata\n")
file:write(".align 1\n")
file:write(const_name_prefix.."_Tiles_SizeY:\n")
file:write(".hword "..h.."\n")
file:write("\n")
file:write("@===============================================================================\n")
file:write("@ "..const_name_prefix.."_Tiles\n")
file:write("@===============================================================================\n")
file:write(".global "..const_name_prefix.."_Tiles\n")
file:write(".type "..const_name_prefix.."_Tiles, %object\n")
file:write(".section .rodata\n")
file:write(".align 2\n")
file:write(const_name_prefix.."_Tiles:\n")

colscounter=1
const_type_written=0
for y = 0, h - 1 , 8 do
 for x = 0, w - 1 , 8 do
  for ty = y, y + 7 , 1 do
   for tx = x, x + 7 , 1 do
    col = getpicturepixel(tx, ty)
    colhex=num2hex(col)
    ZEROS=""
    strlen=string.len(colhex)
    for i = 1, 2-strlen, 1 do --2 = byte
     ZEROS=ZEROS.."0"
    end
    if colscounter == 8 then
     colscounter=1
     col2write="0x"..ZEROS..colhex.."\n"
     const_type_written=0
    else
     colscounter=colscounter+1
     if const_type_written == 0 then
      const_type_written=1
      file:write(".byte ")
     end
     col2write="0x"..ZEROS..colhex..", "
    end
--  messagebox("nOp", col2write)
    file:write(col2write)
   end
  end
 end
end

file:close()
